(function ($) {
	/**
	 * Filter the menu items in the table at admin/build/mew.
	 */
	Drupal.behaviors.mewFilter = function (context) {
		$('#mew-form-list').bind('submit', function(){
			return false;
		});
		$('#edit-keywords').bind('keyup', function() {
			var keywords = [];
			var fragments = this.value.split(' ');
			for (i in fragments) {
				keywords.push(fragments[i].toLowerCase());
			}
			var count = -1;
			// Clone the table body, so we can perform all manipulations behind the
			// scenes and the browser only needs to render the new table once.
			var table = $('#mew-list tbody');
			var table_clone = table.clone();
			table_clone.find('tr').each(function() {
				var cells = $(this).find('td');
				// Check the URL path and link title, which are the first two cells.
				var strings = [cells.get(0).innerHTML.toLowerCase(), cells.get(1).innerHTML.toLowerCase()];
				var matches = [true, true];
				for (i in strings) {
					// Check if all keywords are present in this string.
					for (j in keywords) {
						if (strings[i].indexOf(keywords[j]) == -1) {
							matches[i] = false;
						}
					}
				}
				// All keywords are present the path or title, so show the table row.
				if (matches[0] || matches[1]) {
					var class = count++ % 2 == 0 ? 'even' : 'odd';
					$(this).removeClass('even odd').addClass(class).show();
				}
				// Not all keywords are present, so hide the table row.
				else {
					$(this).hide();
				}
			});
			table.replaceWith(table_clone);
		});
	}
})(jQuery);